#
# tkgetpath V1.0
# Copyright (c) 2008 Satoshi Imai
#
package require twapi
package require tkdnd

if {$tk_version < 8.5} {
    tk_messageBox \
        -icon    error \
        -title   "Version Error!" \
        -type    ok \
        -message {Tcl/Tk > 8.5 is required!}
    exit
}

# e[}I
::ttk::setTheme xpnative

# Nǂ邩ǂ
set follow 1

# GUI
ttk::frame .f1
ttk::frame .f2
ttk::frame .f3
pack .f1 -side top -fill x
pack .f2 -side top -fill x
pack .f3 -side top -fill both -expand 1

ttk::label .label -text {IvV: }
ttk::checkbutton .follow -text {N⃊[gɒu} -variable follow
ttk::button .copy -text {Rs[} -state disabled -command Copy
grid .label -in .f1 -row 0 -column 0 -padx 5 -sticky w
grid .follow -in .f1 -row 0 -column 1 -padx 5 -sticky w
grid .copy -in .f1 -row 0 -column 2 -padx 5;# -sticky e
grid columnconfigure .f1 0 -weight 0
grid columnconfigure .f1 1 -weight 1
grid columnconfigure .f1 2 -weight 0

ttk::label .drop -text {Ƀt@C܂̓tH_hbvĂB}
grid .drop -in .f2 -row 0 -column 0 -padx 5 -sticky w

listbox .list -width 60 -height 20 -yscroll {.sv set} -xscroll {.sh set} -selectmode extended
ttk::scrollbar .sv -command {.list yview}
ttk::scrollbar .sh -orient horizontal -command {.list xview}
ttk::sizegrip .sz
grid .list -in .f3 -row 0 -column 0 -sticky nsew
grid .sv -in .f3 -row 0 -column 1 -sticky ns
grid .sh -in .f3 -row 1 -column 0 -sticky we
grid .sz -in .f3 -row 1 -column 1
grid columnconfigure .f3 0 -weight 1
grid rowconfigure .f3 0 -weight 1

tkdnd::drop_target register .list CF_HDROP

# t@C܂̓tH_hbvꂽƂ̏
dnd bindtarget .list text/uri-list <Drop> {
	foreach path %D {
		set url 0
		if {$follow == 1 && [file extension $path] == ".url"} {
			set path [ReadUrlFile $path]
			set url 1
		}
		if {$follow == 1 && [file extension $path] == ".lnk"} {
			set path [ReadLnkFile $path]
		}
		if {$follow == 1 && $url == 0} {
			set drive [ChangeRemoteName [lindex [file split $path] 0]]
			set path [file join $drive {*}[lrange [file split $path] 1 end]]
		}
		if {$url == 0} {
			set path [file nativename $path]
		}
	    .list insert end $path
		.list selection clear 0 end
		.list selection set end
		.copy configure -state enabled
		.list see end
	}
}

# hCu^[[gɕϊ
proc ChangeRemoteName {drive} {
	set letter [string trim $drive /]
	if {![catch {twapi::get_mapped_share_info $letter -uncpath}]} {
		return [lindex [twapi::get_mapped_share_info $letter -uncpath] 1]
	} else {
		return $drive
	}
}

# Nbv{[hփRs[
proc Copy {} {
	set sel [.list curselection]
	# Nbv{[hNA
	clipboard clear -displayof .list
	# Nbv{[h֕ǉ
	foreach str $sel {
		clipboard append -displayof .list "[.list get $str]\n"
	}
}

# ׂđI
proc SelectAll {} {
	.list selection set 0 end
}

# 폜
proc Delete {} {
	set sel [.list curselection]
	foreach n [lreverse $sel] {
		.list delete $n
	}
}

# Nbv{[hփRs[
bind Text <<Copy>> {
	Copy
}

# ׂđI
bind .list <Control-a> {
	SelectAll
}

# 폜
bind .list <Delete> {
	Delete
}

# Nt@C̃NԂ
proc ReadLnkFile {lnk} {
	return [lindex [twapi::read_shortcut $lnk] 7]
}

# URLt@C̃NԂ
proc ReadUrlFile {url} {
	return [twapi::read_url_shortcut $url]
}

# E{^j[
menu .popup -tearoff no
.popup add command -label {Rs[(C)} -underline 4 -accelerator "Ctrl+C" -command Copy
.popup add separator
.popup add command -label {ׂđI(A)} -underline 6 -accelerator "Ctrl+A" -command SelectAll
#.popup add separator
.popup add command -label {폜(D)} -underline 3 -accelerator "DEL" -command Delete
bind .list <3> { tk_popup .popup %X %Y }

# o[W\
menu .menu
. configure -menu .menu
menu .menu.system -tearoff 0
.menu.system add separator
.menu.system add command -label {o[W\...} \
	-command {tk_messageBox -icon info -title {o[W} \
		-message "tkgetpath V1.0\nCopyright (c) 2008 Satoshi Imai"}
.menu add cascade -label System -menu .menu.system
